From 4dab24746ef68df95a9e0d5abe870a57502fb3d3 Mon Sep 17 00:00:00 2001
From: Michael Haubenwallner <michael.haubenwallner@ssi-schaefer.com>
Date: Tue, 21 May 2019 18:29:15 +0200
Subject: [PATCH 10/21] if already set, let CFLAGS/CXXFLAGS alone by default

Do not tweak CFLAGS/CXXFLAGS if already set and optimize or debug is not
explicitly requested by configure arguments.
---
 configure.in | 32 +++++++++++++++++++-------------
 1 file changed, 19 insertions(+), 13 deletions(-)

diff --git a/configure.in b/configure.in
index 0d42c77..4b7e60c 100644
--- a/configure.in
+++ b/configure.in
@@ -112,12 +112,12 @@ AC_ARG_ENABLE(repo,
  use_repo=$enableval, use_repo=no)
 
 AC_ARG_ENABLE(optimize,
- [  --disable-optimize      do not use -O2 to compile],
- use_opt=$enableval, use_opt=yes)
+ [  --enable-optimize       use -O2 to compile],
+ use_opt=$enableval, ${CFLAGS+true} false && use_opt=default || use_opt=yes)
 
 AC_ARG_ENABLE(debug,
  [  --enable-debug          use -g to compile],
- use_debug=$enableval, use_debug=no)
+ use_debug=$enableval, ${CFLAGS+true} false && use_debug=default || use_opt=yes)
 
 AC_ARG_ENABLE(shared,
  [  --disable-shared        don't build shared libs],
@@ -969,7 +969,7 @@ else
       CONF_SHARED_CC="$CXX -shared"
       CONF_PICFLAGS=-fPIC
       CONF_LDSOFLAGS=-fPIC
-      if test X"$use_opt" != Xyes; then
+      if test X"$use_opt" = Xno; then
         # by default Intel uses -O so we need to disable it
         CONF_OPT_FLAGS=-O0
         use_opt=yes
@@ -1025,17 +1025,23 @@ fi
 #
 
 changequote(<<, >>)
-CXXFLAGS=`echo " $CXXFLAGS " | sed -e 's/ -g / /g' -e 's/ -O[0-9]* / /g'`
-CFLAGS=`echo " $CFLAGS " | sed -e 's/ -g / /g' -e 's/ -O[0-9]* / /g'`
-changequote([, ])
-if test X"$use_opt" != Xno; then
-  CXXFLAGS="$CONF_OPT_FLAGS $CXXFLAGS"
-  CFLAGS="$CONF_OPT_FLAGS $CFLAGS"
+if test X"$use_opt" != Xdefault; then
+  CXXFLAGS=`echo " $CXXFLAGS " | sed -e 's/ -O[0-9]* / /g'`
+  CFLAGS=`echo " $CFLAGS " | sed -e 's/ -O[0-9]* / /g'`
+  if test X"$use_opt" = Xyes; then
+    CXXFLAGS="$CONF_OPT_FLAGS $CXXFLAGS"
+    CFLAGS="$CONF_OPT_FLAGS $CFLAGS"
+  fi
 fi
-if test X"$use_debug" != Xno; then
-  CXXFLAGS="$CONF_DEBUG_FLAGS $CXXFLAGS"
-  CFLAGS="$CONF_DEBUG_FLAGS $CFLAGS"
+if test X"$use_debug" != Xdefault; then
+  CXXFLAGS=`echo " $CXXFLAGS " | sed -e 's/ -g / /g'`
+  CFLAGS=`echo " $CFLAGS " | sed -e 's/ -g / /g'`
+  if test X"$use_debug" = Xyes; then
+    CXXFLAGS="$CONF_DEBUG_FLAGS $CXXFLAGS"
+    CFLAGS="$CONF_DEBUG_FLAGS $CFLAGS"
+  fi
 fi
+changequote([, ])
 
 if test "x$use_memcheck" = "xyes" ; then
     case $target in

